package main
import(
"context"
"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
"github.com/conductorone/conductorone-sdk-go/pkg/models/operations"
"log"
)
func main() {
ctx := context.Background()
s := conductoronesdkgo.New(
conductoronesdkgo.WithSecurity(shared.Security{
BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
Oauth: "<YOUR_OAUTH_HERE>",
}),
)
res, err := s.Automation.UpdateAutomation(ctx, operations.C1APIAutomationsV1AutomationServiceUpdateAutomationRequest{
ID: "<id>",
})
if err != nil {
log.Fatal(err)
}
if res.UpdateAutomationResponse != nil {
// handle response
}
}import { ConductoroneSDKTypescript } from "conductorone-sdk-typescript";
const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
security: {
bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
oauth: "<YOUR_OAUTH_HERE>",
},
});
async function run() {
const result = await conductoroneSDKTypescript.automation.updateAutomation({
id: "<id>",
});
console.log(result);
}
run();curl --request POST \
--url https://{tenantDomain}.conductor.one/api/v1/automations/{id} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"automation": {
"annotations": {},
"appId": "<string>",
"automationSteps": [
{
"accountLifecycleAction": {
"accountInContext": {},
"accountRef": {
"accountIdCel": "<string>"
},
"actionName": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
}
},
"callFunction": {
"args": {},
"functionId": "<string>"
},
"connectorAction": {
"actionName": "<string>",
"argsTemplate": {},
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"resourceTypeId": "<string>"
},
"connectorCreateAccount": {
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>",
"userIdCel": "<string>",
"userProperties": {
"displayNameCel": "<string>",
"emailCel": "<string>",
"profileAttributeCel": "<string>",
"usernameCel": "<string>"
}
},
"createAccessReview": {
"accessReviewTemplateCel": "<string>",
"accessReviewTemplateId": "<string>",
"campaignName": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"createRevokeTasks": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"appEntitlementRefsCel": "<string>",
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedAppEntitlementRefsCel": "<string>",
"revokeAll": true,
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"createRevokeTasksV2": {
"exclusionCriteria": {
"excludedAppIds": [
"<string>"
],
"excludedComplianceFrameworkIds": [
"<string>"
],
"excludedResourceTypeIds": [
"<string>"
],
"excludedRiskLevelIds": [
"<string>"
]
},
"exclusionList": {
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"exclusionListCel": {
"excludedAppEntitlementRefsCel": "<string>"
},
"exclusionNone": {},
"inclusionAccessOnly": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"evaluateExpressions": {
"expressions": [
{
"expressionCel": "<string>",
"isSecret": true,
"key": "<string>"
}
]
},
"generatePassword": {
"passwordPolicyId": "<string>",
"policy": {
"customCharacters": "<string>",
"excludedCharacters": "<string>",
"maxCharacterCount": 123,
"minCharacterCount": 123,
"noRestrictions": true,
"requireLowercase": true,
"requireNumbers": true,
"requireSpecialCharacters": true,
"requireUppercase": true
}
},
"grantEntitlements": {
"exclusionCriteria": {
"excludedAppIds": [
"<string>"
],
"excludedComplianceFrameworkIds": [
"<string>"
],
"excludedRiskLevelIds": [
"<string>"
]
},
"exclusionList": {
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"exclusionListCel": {
"excludedAppEntitlementRefsCel": "<string>"
},
"exclusionNone": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"removeFromDelegation": {
"replacementUserIdCel": "<string>",
"replacementUserRef": {
"id": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"runAutomation": {
"automationTemplateIdCel": "<string>",
"automationTemplateRef": {
"id": "<string>"
},
"context": {
"context": {}
}
},
"sendEmail": {
"body": "<string>",
"email": "<string>",
"emailCel": "<string>",
"subject": "<string>",
"title": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"sendSlackMessage": {
"body": "<string>",
"channelName": "<string>",
"channelNameCel": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"setCredential": {
"accountIdCel": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>"
},
"skipIfTrueCel": "<string>",
"stepDisplayName": "<string>",
"stepName": "<string>",
"storeCredential": {
"appIdCel": "<string>",
"credentialCel": "<string>",
"expiry": "<string>",
"labelCel": "<string>",
"maxViews": 123,
"recipientCel": "<string>",
"recipientEmailCel": "<string>",
"ttl": "<string>"
},
"taskAction": {
"close": {
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"reassign": {
"assigneeUserIdCel": "<string>",
"assigneeUserRef": {
"id": "<string>"
},
"subjectUserIdCel": "<string>",
"subjectUserRef": {
"id": "<string>"
},
"useSubjectUser": true
},
"taskTypes": []
},
"unenrollFromAllAccessProfiles": {
"catalogIds": [
"<string>"
],
"catalogIdsCel": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"updateUser": {
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
},
"userStatusCel": "<string>"
},
"waitForDuration": {
"duration": "<string>"
},
"webhook": {
"payload": {},
"webhookId": "<string>",
"webhookIdCel": "<string>"
}
}
],
"circuitBreaker": {
"observedCount": 123,
"threshold": 123,
"trippedAt": "2023-11-07T05:31:56Z"
},
"circuitBreakerMax": 123,
"context": {
"context": {}
},
"createdAt": "2023-11-07T05:31:56Z",
"currentVersion": "<string>",
"description": "<string>",
"displayName": "<string>",
"draftAutomationSteps": [
{
"accountLifecycleAction": {
"accountInContext": {},
"accountRef": {
"accountIdCel": "<string>"
},
"actionName": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
}
},
"callFunction": {
"args": {},
"functionId": "<string>"
},
"connectorAction": {
"actionName": "<string>",
"argsTemplate": {},
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"resourceTypeId": "<string>"
},
"connectorCreateAccount": {
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>",
"userIdCel": "<string>",
"userProperties": {
"displayNameCel": "<string>",
"emailCel": "<string>",
"profileAttributeCel": "<string>",
"usernameCel": "<string>"
}
},
"createAccessReview": {
"accessReviewTemplateCel": "<string>",
"accessReviewTemplateId": "<string>",
"campaignName": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"createRevokeTasks": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"appEntitlementRefsCel": "<string>",
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedAppEntitlementRefsCel": "<string>",
"revokeAll": true,
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"createRevokeTasksV2": {
"exclusionCriteria": {
"excludedAppIds": [
"<string>"
],
"excludedComplianceFrameworkIds": [
"<string>"
],
"excludedResourceTypeIds": [
"<string>"
],
"excludedRiskLevelIds": [
"<string>"
]
},
"exclusionList": {
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"exclusionListCel": {
"excludedAppEntitlementRefsCel": "<string>"
},
"exclusionNone": {},
"inclusionAccessOnly": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"evaluateExpressions": {
"expressions": [
{
"expressionCel": "<string>",
"isSecret": true,
"key": "<string>"
}
]
},
"generatePassword": {
"passwordPolicyId": "<string>",
"policy": {
"customCharacters": "<string>",
"excludedCharacters": "<string>",
"maxCharacterCount": 123,
"minCharacterCount": 123,
"noRestrictions": true,
"requireLowercase": true,
"requireNumbers": true,
"requireSpecialCharacters": true,
"requireUppercase": true
}
},
"grantEntitlements": {
"exclusionCriteria": {
"excludedAppIds": [
"<string>"
],
"excludedComplianceFrameworkIds": [
"<string>"
],
"excludedRiskLevelIds": [
"<string>"
]
},
"exclusionList": {
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"exclusionListCel": {
"excludedAppEntitlementRefsCel": "<string>"
},
"exclusionNone": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"removeFromDelegation": {
"replacementUserIdCel": "<string>",
"replacementUserRef": {
"id": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"runAutomation": {
"automationTemplateIdCel": "<string>",
"automationTemplateRef": {
"id": "<string>"
},
"context": {
"context": {}
}
},
"sendEmail": {
"body": "<string>",
"email": "<string>",
"emailCel": "<string>",
"subject": "<string>",
"title": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"sendSlackMessage": {
"body": "<string>",
"channelName": "<string>",
"channelNameCel": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"setCredential": {
"accountIdCel": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>"
},
"skipIfTrueCel": "<string>",
"stepDisplayName": "<string>",
"stepName": "<string>",
"storeCredential": {
"appIdCel": "<string>",
"credentialCel": "<string>",
"expiry": "<string>",
"labelCel": "<string>",
"maxViews": 123,
"recipientCel": "<string>",
"recipientEmailCel": "<string>",
"ttl": "<string>"
},
"taskAction": {
"close": {
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"reassign": {
"assigneeUserIdCel": "<string>",
"assigneeUserRef": {
"id": "<string>"
},
"subjectUserIdCel": "<string>",
"subjectUserRef": {
"id": "<string>"
},
"useSubjectUser": true
},
"taskTypes": []
},
"unenrollFromAllAccessProfiles": {
"catalogIds": [
"<string>"
],
"catalogIdsCel": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"updateUser": {
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
},
"userStatusCel": "<string>"
},
"waitForDuration": {
"duration": "<string>"
},
"webhook": {
"payload": {},
"webhookId": "<string>",
"webhookIdCel": "<string>"
}
}
],
"draftTriggers": [
{
"accessConflict": {
"allConflictMonitors": true,
"conflictMonitorRefs": {
"conflictMonitorRefs": [
{
"id": "<string>"
}
]
}
},
"appUserCreated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"appUserUpdated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"grantDeleted": {
"grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
}
}
},
"grantFound": {
"grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
}
}
},
"schedule": {
"advanced": true,
"condition": "<string>",
"cronSpec": "<string>",
"skipIfTrueCel": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleAppUser": {
"appId": "<string>",
"condition": "<string>",
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleNoUser": {
"advanced": true,
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"usageBasedRevocation": {
"appId": "<string>",
"enabledAt": "2023-11-07T05:31:56Z",
"excludedGroupRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedUserRefs": [
{
"id": "<string>"
}
],
"includeUsersWithNoActivity": true,
"runDelayed": {
"coldStartDelayDays": 123
},
"runImmediately": {},
"targetedAppUserTypes": [],
"targetedEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"unusedForDays": 123
},
"userCreated": {
"condition": "<string>"
},
"userProfileChange": {
"condition": "<string>"
},
"webhook": {
"capabilityUrl": {},
"hmac": {},
"jwt": {
"jwksUrl": "<string>"
},
"listenerId": "<string>"
}
}
],
"enabled": true,
"isDraft": true,
"lastExecutedAt": "2023-11-07T05:31:56Z",
"triggers": [
{
"accessConflict": {
"allConflictMonitors": true,
"conflictMonitorRefs": {
"conflictMonitorRefs": [
{
"id": "<string>"
}
]
}
},
"appUserCreated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"appUserUpdated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"grantDeleted": {
"grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
}
}
},
"grantFound": {
"grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
}
}
},
"schedule": {
"advanced": true,
"condition": "<string>",
"cronSpec": "<string>",
"skipIfTrueCel": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleAppUser": {
"appId": "<string>",
"condition": "<string>",
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleNoUser": {
"advanced": true,
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"usageBasedRevocation": {
"appId": "<string>",
"enabledAt": "2023-11-07T05:31:56Z",
"excludedGroupRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedUserRefs": [
{
"id": "<string>"
}
],
"includeUsersWithNoActivity": true,
"runDelayed": {
"coldStartDelayDays": 123
},
"runImmediately": {},
"targetedAppUserTypes": [],
"targetedEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"unusedForDays": 123
},
"userCreated": {
"condition": "<string>"
},
"userProfileChange": {
"condition": "<string>"
},
"webhook": {
"capabilityUrl": {},
"hmac": {},
"jwt": {
"jwksUrl": "<string>"
},
"listenerId": "<string>"
}
}
]
},
"updateMask": "<string>"
}
'import requests
url = "https://{tenantDomain}.conductor.one/api/v1/automations/{id}"
payload = {
"automation": {
"annotations": {},
"appId": "<string>",
"automationSteps": [
{
"accountLifecycleAction": {
"accountInContext": {},
"accountRef": { "accountIdCel": "<string>" },
"actionName": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
}
},
"callFunction": {
"args": {},
"functionId": "<string>"
},
"connectorAction": {
"actionName": "<string>",
"argsTemplate": {},
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"resourceTypeId": "<string>"
},
"connectorCreateAccount": {
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>",
"userIdCel": "<string>",
"userProperties": {
"displayNameCel": "<string>",
"emailCel": "<string>",
"profileAttributeCel": "<string>",
"usernameCel": "<string>"
}
},
"createAccessReview": {
"accessReviewTemplateCel": "<string>",
"accessReviewTemplateId": "<string>",
"campaignName": "<string>",
"useSubjectUser": True,
"userIdsCel": "<string>",
"userRefs": [{ "id": "<string>" }]
},
"createRevokeTasks": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"appEntitlementRefsCel": "<string>",
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedAppEntitlementRefsCel": "<string>",
"revokeAll": True,
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"createRevokeTasksV2": {
"exclusionCriteria": {
"excludedAppIds": ["<string>"],
"excludedComplianceFrameworkIds": ["<string>"],
"excludedResourceTypeIds": ["<string>"],
"excludedRiskLevelIds": ["<string>"]
},
"exclusionList": { "excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"exclusionListCel": { "excludedAppEntitlementRefsCel": "<string>" },
"exclusionNone": {},
"inclusionAccessOnly": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": ["<string>"],
"complianceFrameworkIds": ["<string>"],
"resourceTypeIds": ["<string>"],
"riskLevelIds": ["<string>"]
},
"inclusionList": { "appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"inclusionListCel": { "appEntitlementRefsCel": "<string>" },
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"evaluateExpressions": { "expressions": [
{
"expressionCel": "<string>",
"isSecret": True,
"key": "<string>"
}
] },
"generatePassword": {
"passwordPolicyId": "<string>",
"policy": {
"customCharacters": "<string>",
"excludedCharacters": "<string>",
"maxCharacterCount": 123,
"minCharacterCount": 123,
"noRestrictions": True,
"requireLowercase": True,
"requireNumbers": True,
"requireSpecialCharacters": True,
"requireUppercase": True
}
},
"grantEntitlements": {
"exclusionCriteria": {
"excludedAppIds": ["<string>"],
"excludedComplianceFrameworkIds": ["<string>"],
"excludedRiskLevelIds": ["<string>"]
},
"exclusionList": { "excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"exclusionListCel": { "excludedAppEntitlementRefsCel": "<string>" },
"exclusionNone": {},
"inclusionCriteria": {
"appIds": ["<string>"],
"complianceFrameworkIds": ["<string>"],
"riskLevelIds": ["<string>"]
},
"inclusionList": { "appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"inclusionListCel": { "appEntitlementRefsCel": "<string>" },
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"removeFromDelegation": {
"replacementUserIdCel": "<string>",
"replacementUserRef": { "id": "<string>" },
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"runAutomation": {
"automationTemplateIdCel": "<string>",
"automationTemplateRef": { "id": "<string>" },
"context": { "context": {} }
},
"sendEmail": {
"body": "<string>",
"email": "<string>",
"emailCel": "<string>",
"subject": "<string>",
"title": "<string>",
"useSubjectUser": True,
"userIdsCel": "<string>",
"userRefs": [{ "id": "<string>" }]
},
"sendSlackMessage": {
"body": "<string>",
"channelName": "<string>",
"channelNameCel": "<string>",
"useSubjectUser": True,
"userIdsCel": "<string>",
"userRefs": [{ "id": "<string>" }]
},
"setCredential": {
"accountIdCel": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>"
},
"skipIfTrueCel": "<string>",
"stepDisplayName": "<string>",
"stepName": "<string>",
"storeCredential": {
"appIdCel": "<string>",
"credentialCel": "<string>",
"expiry": "<string>",
"labelCel": "<string>",
"maxViews": 123,
"recipientCel": "<string>",
"recipientEmailCel": "<string>",
"ttl": "<string>"
},
"taskAction": {
"close": {
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"reassign": {
"assigneeUserIdCel": "<string>",
"assigneeUserRef": { "id": "<string>" },
"subjectUserIdCel": "<string>",
"subjectUserRef": { "id": "<string>" },
"useSubjectUser": True
},
"taskTypes": []
},
"unenrollFromAllAccessProfiles": {
"catalogIds": ["<string>"],
"catalogIdsCel": "<string>",
"useSubjectUser": True,
"userIdsCel": "<string>",
"userRefs": [{ "id": "<string>" }]
},
"updateUser": {
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" },
"userStatusCel": "<string>"
},
"waitForDuration": { "duration": "<string>" },
"webhook": {
"payload": {},
"webhookId": "<string>",
"webhookIdCel": "<string>"
}
}
],
"circuitBreaker": {
"observedCount": 123,
"threshold": 123,
"trippedAt": "2023-11-07T05:31:56Z"
},
"circuitBreakerMax": 123,
"context": { "context": {} },
"createdAt": "2023-11-07T05:31:56Z",
"currentVersion": "<string>",
"description": "<string>",
"displayName": "<string>",
"draftAutomationSteps": [
{
"accountLifecycleAction": {
"accountInContext": {},
"accountRef": { "accountIdCel": "<string>" },
"actionName": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
}
},
"callFunction": {
"args": {},
"functionId": "<string>"
},
"connectorAction": {
"actionName": "<string>",
"argsTemplate": {},
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"resourceTypeId": "<string>"
},
"connectorCreateAccount": {
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>",
"userIdCel": "<string>",
"userProperties": {
"displayNameCel": "<string>",
"emailCel": "<string>",
"profileAttributeCel": "<string>",
"usernameCel": "<string>"
}
},
"createAccessReview": {
"accessReviewTemplateCel": "<string>",
"accessReviewTemplateId": "<string>",
"campaignName": "<string>",
"useSubjectUser": True,
"userIdsCel": "<string>",
"userRefs": [{ "id": "<string>" }]
},
"createRevokeTasks": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"appEntitlementRefsCel": "<string>",
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedAppEntitlementRefsCel": "<string>",
"revokeAll": True,
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"createRevokeTasksV2": {
"exclusionCriteria": {
"excludedAppIds": ["<string>"],
"excludedComplianceFrameworkIds": ["<string>"],
"excludedResourceTypeIds": ["<string>"],
"excludedRiskLevelIds": ["<string>"]
},
"exclusionList": { "excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"exclusionListCel": { "excludedAppEntitlementRefsCel": "<string>" },
"exclusionNone": {},
"inclusionAccessOnly": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": ["<string>"],
"complianceFrameworkIds": ["<string>"],
"resourceTypeIds": ["<string>"],
"riskLevelIds": ["<string>"]
},
"inclusionList": { "appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"inclusionListCel": { "appEntitlementRefsCel": "<string>" },
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"evaluateExpressions": { "expressions": [
{
"expressionCel": "<string>",
"isSecret": True,
"key": "<string>"
}
] },
"generatePassword": {
"passwordPolicyId": "<string>",
"policy": {
"customCharacters": "<string>",
"excludedCharacters": "<string>",
"maxCharacterCount": 123,
"minCharacterCount": 123,
"noRestrictions": True,
"requireLowercase": True,
"requireNumbers": True,
"requireSpecialCharacters": True,
"requireUppercase": True
}
},
"grantEntitlements": {
"exclusionCriteria": {
"excludedAppIds": ["<string>"],
"excludedComplianceFrameworkIds": ["<string>"],
"excludedRiskLevelIds": ["<string>"]
},
"exclusionList": { "excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"exclusionListCel": { "excludedAppEntitlementRefsCel": "<string>" },
"exclusionNone": {},
"inclusionCriteria": {
"appIds": ["<string>"],
"complianceFrameworkIds": ["<string>"],
"riskLevelIds": ["<string>"]
},
"inclusionList": { "appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"inclusionListCel": { "appEntitlementRefsCel": "<string>" },
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"removeFromDelegation": {
"replacementUserIdCel": "<string>",
"replacementUserRef": { "id": "<string>" },
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"runAutomation": {
"automationTemplateIdCel": "<string>",
"automationTemplateRef": { "id": "<string>" },
"context": { "context": {} }
},
"sendEmail": {
"body": "<string>",
"email": "<string>",
"emailCel": "<string>",
"subject": "<string>",
"title": "<string>",
"useSubjectUser": True,
"userIdsCel": "<string>",
"userRefs": [{ "id": "<string>" }]
},
"sendSlackMessage": {
"body": "<string>",
"channelName": "<string>",
"channelNameCel": "<string>",
"useSubjectUser": True,
"userIdsCel": "<string>",
"userRefs": [{ "id": "<string>" }]
},
"setCredential": {
"accountIdCel": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>"
},
"skipIfTrueCel": "<string>",
"stepDisplayName": "<string>",
"stepName": "<string>",
"storeCredential": {
"appIdCel": "<string>",
"credentialCel": "<string>",
"expiry": "<string>",
"labelCel": "<string>",
"maxViews": 123,
"recipientCel": "<string>",
"recipientEmailCel": "<string>",
"ttl": "<string>"
},
"taskAction": {
"close": {
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" }
},
"reassign": {
"assigneeUserIdCel": "<string>",
"assigneeUserRef": { "id": "<string>" },
"subjectUserIdCel": "<string>",
"subjectUserRef": { "id": "<string>" },
"useSubjectUser": True
},
"taskTypes": []
},
"unenrollFromAllAccessProfiles": {
"catalogIds": ["<string>"],
"catalogIdsCel": "<string>",
"useSubjectUser": True,
"userIdsCel": "<string>",
"userRefs": [{ "id": "<string>" }]
},
"updateUser": {
"useSubjectUser": True,
"userIdCel": "<string>",
"userRef": { "id": "<string>" },
"userStatusCel": "<string>"
},
"waitForDuration": { "duration": "<string>" },
"webhook": {
"payload": {},
"webhookId": "<string>",
"webhookIdCel": "<string>"
}
}
],
"draftTriggers": [
{
"accessConflict": {
"allConflictMonitors": True,
"conflictMonitorRefs": { "conflictMonitorRefs": [{ "id": "<string>" }] }
},
"appUserCreated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"appUserUpdated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"grantDeleted": { "grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": ["<string>"],
"complianceFrameworkIds": ["<string>"],
"resourceTypeIds": ["<string>"],
"riskLevelIds": ["<string>"]
},
"inclusionList": { "appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"inclusionListCel": { "appEntitlementRefsCel": "<string>" }
} },
"grantFound": { "grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": ["<string>"],
"complianceFrameworkIds": ["<string>"],
"resourceTypeIds": ["<string>"],
"riskLevelIds": ["<string>"]
},
"inclusionList": { "appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"inclusionListCel": { "appEntitlementRefsCel": "<string>" }
} },
"schedule": {
"advanced": True,
"condition": "<string>",
"cronSpec": "<string>",
"skipIfTrueCel": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleAppUser": {
"appId": "<string>",
"condition": "<string>",
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleNoUser": {
"advanced": True,
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"usageBasedRevocation": {
"appId": "<string>",
"enabledAt": "2023-11-07T05:31:56Z",
"excludedGroupRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedUserRefs": [{ "id": "<string>" }],
"includeUsersWithNoActivity": True,
"runDelayed": { "coldStartDelayDays": 123 },
"runImmediately": {},
"targetedAppUserTypes": [],
"targetedEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"unusedForDays": 123
},
"userCreated": { "condition": "<string>" },
"userProfileChange": { "condition": "<string>" },
"webhook": {
"capabilityUrl": {},
"hmac": {},
"jwt": { "jwksUrl": "<string>" },
"listenerId": "<string>"
}
}
],
"enabled": True,
"isDraft": True,
"lastExecutedAt": "2023-11-07T05:31:56Z",
"triggers": [
{
"accessConflict": {
"allConflictMonitors": True,
"conflictMonitorRefs": { "conflictMonitorRefs": [{ "id": "<string>" }] }
},
"appUserCreated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"appUserUpdated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"grantDeleted": { "grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": ["<string>"],
"complianceFrameworkIds": ["<string>"],
"resourceTypeIds": ["<string>"],
"riskLevelIds": ["<string>"]
},
"inclusionList": { "appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"inclusionListCel": { "appEntitlementRefsCel": "<string>" }
} },
"grantFound": { "grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": ["<string>"],
"complianceFrameworkIds": ["<string>"],
"resourceTypeIds": ["<string>"],
"riskLevelIds": ["<string>"]
},
"inclusionList": { "appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
] },
"inclusionListCel": { "appEntitlementRefsCel": "<string>" }
} },
"schedule": {
"advanced": True,
"condition": "<string>",
"cronSpec": "<string>",
"skipIfTrueCel": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleAppUser": {
"appId": "<string>",
"condition": "<string>",
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleNoUser": {
"advanced": True,
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"usageBasedRevocation": {
"appId": "<string>",
"enabledAt": "2023-11-07T05:31:56Z",
"excludedGroupRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedUserRefs": [{ "id": "<string>" }],
"includeUsersWithNoActivity": True,
"runDelayed": { "coldStartDelayDays": 123 },
"runImmediately": {},
"targetedAppUserTypes": [],
"targetedEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"unusedForDays": 123
},
"userCreated": { "condition": "<string>" },
"userProfileChange": { "condition": "<string>" },
"webhook": {
"capabilityUrl": {},
"hmac": {},
"jwt": { "jwksUrl": "<string>" },
"listenerId": "<string>"
}
}
]
},
"updateMask": "<string>"
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
automation: {
annotations: {},
appId: '<string>',
automationSteps: [
{
accountLifecycleAction: {
accountInContext: {},
accountRef: {accountIdCel: '<string>'},
actionName: '<string>',
connectorRef: {appId: '<string>', id: '<string>'}
},
callFunction: {args: {}, functionId: '<string>'},
connectorAction: {
actionName: '<string>',
argsTemplate: {},
connectorRef: {appId: '<string>', id: '<string>'},
resourceTypeId: '<string>'
},
connectorCreateAccount: {
connectorRef: {appId: '<string>', id: '<string>'},
passwordCel: '<string>',
userIdCel: '<string>',
userProperties: {
displayNameCel: '<string>',
emailCel: '<string>',
profileAttributeCel: '<string>',
usernameCel: '<string>'
}
},
createAccessReview: {
accessReviewTemplateCel: '<string>',
accessReviewTemplateId: '<string>',
campaignName: '<string>',
useSubjectUser: true,
userIdsCel: '<string>',
userRefs: [{id: '<string>'}]
},
createRevokeTasks: {
appEntitlementRefs: [{appId: '<string>', id: '<string>'}],
appEntitlementRefsCel: '<string>',
excludedAppEntitlementRefs: [{appId: '<string>', id: '<string>'}],
excludedAppEntitlementRefsCel: '<string>',
revokeAll: true,
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'}
},
createRevokeTasksV2: {
exclusionCriteria: {
excludedAppIds: ['<string>'],
excludedComplianceFrameworkIds: ['<string>'],
excludedResourceTypeIds: ['<string>'],
excludedRiskLevelIds: ['<string>']
},
exclusionList: {excludedAppEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
exclusionListCel: {excludedAppEntitlementRefsCel: '<string>'},
exclusionNone: {},
inclusionAccessOnly: {},
inclusionAll: {},
inclusionCriteria: {
appIds: ['<string>'],
complianceFrameworkIds: ['<string>'],
resourceTypeIds: ['<string>'],
riskLevelIds: ['<string>']
},
inclusionList: {appEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
inclusionListCel: {appEntitlementRefsCel: '<string>'},
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'}
},
evaluateExpressions: {expressions: [{expressionCel: '<string>', isSecret: true, key: '<string>'}]},
generatePassword: {
passwordPolicyId: '<string>',
policy: {
customCharacters: '<string>',
excludedCharacters: '<string>',
maxCharacterCount: 123,
minCharacterCount: 123,
noRestrictions: true,
requireLowercase: true,
requireNumbers: true,
requireSpecialCharacters: true,
requireUppercase: true
}
},
grantEntitlements: {
exclusionCriteria: {
excludedAppIds: ['<string>'],
excludedComplianceFrameworkIds: ['<string>'],
excludedRiskLevelIds: ['<string>']
},
exclusionList: {excludedAppEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
exclusionListCel: {excludedAppEntitlementRefsCel: '<string>'},
exclusionNone: {},
inclusionCriteria: {
appIds: ['<string>'],
complianceFrameworkIds: ['<string>'],
riskLevelIds: ['<string>']
},
inclusionList: {appEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
inclusionListCel: {appEntitlementRefsCel: '<string>'},
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'}
},
removeFromDelegation: {
replacementUserIdCel: '<string>',
replacementUserRef: {id: '<string>'},
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'}
},
runAutomation: {
automationTemplateIdCel: '<string>',
automationTemplateRef: {id: '<string>'},
context: {context: {}}
},
sendEmail: {
body: JSON.stringify('<string>'),
email: '<string>',
emailCel: '<string>',
subject: '<string>',
title: '<string>',
useSubjectUser: true,
userIdsCel: '<string>',
userRefs: [{id: '<string>'}]
},
sendSlackMessage: {
body: JSON.stringify('<string>'),
channelName: '<string>',
channelNameCel: '<string>',
useSubjectUser: true,
userIdsCel: '<string>',
userRefs: [{id: '<string>'}]
},
setCredential: {
accountIdCel: '<string>',
connectorRef: {appId: '<string>', id: '<string>'},
passwordCel: '<string>'
},
skipIfTrueCel: '<string>',
stepDisplayName: '<string>',
stepName: '<string>',
storeCredential: {
appIdCel: '<string>',
credentialCel: '<string>',
expiry: '<string>',
labelCel: '<string>',
maxViews: 123,
recipientCel: '<string>',
recipientEmailCel: '<string>',
ttl: '<string>'
},
taskAction: {
close: {useSubjectUser: true, userIdCel: '<string>', userRef: {id: '<string>'}},
reassign: {
assigneeUserIdCel: '<string>',
assigneeUserRef: {id: '<string>'},
subjectUserIdCel: '<string>',
subjectUserRef: {id: '<string>'},
useSubjectUser: true
},
taskTypes: []
},
unenrollFromAllAccessProfiles: {
catalogIds: ['<string>'],
catalogIdsCel: '<string>',
useSubjectUser: true,
userIdsCel: '<string>',
userRefs: [{id: '<string>'}]
},
updateUser: {
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'},
userStatusCel: '<string>'
},
waitForDuration: {duration: '<string>'},
webhook: {payload: {}, webhookId: '<string>', webhookIdCel: '<string>'}
}
],
circuitBreaker: {observedCount: 123, threshold: 123, trippedAt: '2023-11-07T05:31:56Z'},
circuitBreakerMax: 123,
context: {context: {}},
createdAt: '2023-11-07T05:31:56Z',
currentVersion: '<string>',
description: '<string>',
displayName: '<string>',
draftAutomationSteps: [
{
accountLifecycleAction: {
accountInContext: {},
accountRef: {accountIdCel: '<string>'},
actionName: '<string>',
connectorRef: {appId: '<string>', id: '<string>'}
},
callFunction: {args: {}, functionId: '<string>'},
connectorAction: {
actionName: '<string>',
argsTemplate: {},
connectorRef: {appId: '<string>', id: '<string>'},
resourceTypeId: '<string>'
},
connectorCreateAccount: {
connectorRef: {appId: '<string>', id: '<string>'},
passwordCel: '<string>',
userIdCel: '<string>',
userProperties: {
displayNameCel: '<string>',
emailCel: '<string>',
profileAttributeCel: '<string>',
usernameCel: '<string>'
}
},
createAccessReview: {
accessReviewTemplateCel: '<string>',
accessReviewTemplateId: '<string>',
campaignName: '<string>',
useSubjectUser: true,
userIdsCel: '<string>',
userRefs: [{id: '<string>'}]
},
createRevokeTasks: {
appEntitlementRefs: [{appId: '<string>', id: '<string>'}],
appEntitlementRefsCel: '<string>',
excludedAppEntitlementRefs: [{appId: '<string>', id: '<string>'}],
excludedAppEntitlementRefsCel: '<string>',
revokeAll: true,
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'}
},
createRevokeTasksV2: {
exclusionCriteria: {
excludedAppIds: ['<string>'],
excludedComplianceFrameworkIds: ['<string>'],
excludedResourceTypeIds: ['<string>'],
excludedRiskLevelIds: ['<string>']
},
exclusionList: {excludedAppEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
exclusionListCel: {excludedAppEntitlementRefsCel: '<string>'},
exclusionNone: {},
inclusionAccessOnly: {},
inclusionAll: {},
inclusionCriteria: {
appIds: ['<string>'],
complianceFrameworkIds: ['<string>'],
resourceTypeIds: ['<string>'],
riskLevelIds: ['<string>']
},
inclusionList: {appEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
inclusionListCel: {appEntitlementRefsCel: '<string>'},
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'}
},
evaluateExpressions: {expressions: [{expressionCel: '<string>', isSecret: true, key: '<string>'}]},
generatePassword: {
passwordPolicyId: '<string>',
policy: {
customCharacters: '<string>',
excludedCharacters: '<string>',
maxCharacterCount: 123,
minCharacterCount: 123,
noRestrictions: true,
requireLowercase: true,
requireNumbers: true,
requireSpecialCharacters: true,
requireUppercase: true
}
},
grantEntitlements: {
exclusionCriteria: {
excludedAppIds: ['<string>'],
excludedComplianceFrameworkIds: ['<string>'],
excludedRiskLevelIds: ['<string>']
},
exclusionList: {excludedAppEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
exclusionListCel: {excludedAppEntitlementRefsCel: '<string>'},
exclusionNone: {},
inclusionCriteria: {
appIds: ['<string>'],
complianceFrameworkIds: ['<string>'],
riskLevelIds: ['<string>']
},
inclusionList: {appEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
inclusionListCel: {appEntitlementRefsCel: '<string>'},
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'}
},
removeFromDelegation: {
replacementUserIdCel: '<string>',
replacementUserRef: {id: '<string>'},
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'}
},
runAutomation: {
automationTemplateIdCel: '<string>',
automationTemplateRef: {id: '<string>'},
context: {context: {}}
},
sendEmail: {
body: JSON.stringify('<string>'),
email: '<string>',
emailCel: '<string>',
subject: '<string>',
title: '<string>',
useSubjectUser: true,
userIdsCel: '<string>',
userRefs: [{id: '<string>'}]
},
sendSlackMessage: {
body: JSON.stringify('<string>'),
channelName: '<string>',
channelNameCel: '<string>',
useSubjectUser: true,
userIdsCel: '<string>',
userRefs: [{id: '<string>'}]
},
setCredential: {
accountIdCel: '<string>',
connectorRef: {appId: '<string>', id: '<string>'},
passwordCel: '<string>'
},
skipIfTrueCel: '<string>',
stepDisplayName: '<string>',
stepName: '<string>',
storeCredential: {
appIdCel: '<string>',
credentialCel: '<string>',
expiry: '<string>',
labelCel: '<string>',
maxViews: 123,
recipientCel: '<string>',
recipientEmailCel: '<string>',
ttl: '<string>'
},
taskAction: {
close: {useSubjectUser: true, userIdCel: '<string>', userRef: {id: '<string>'}},
reassign: {
assigneeUserIdCel: '<string>',
assigneeUserRef: {id: '<string>'},
subjectUserIdCel: '<string>',
subjectUserRef: {id: '<string>'},
useSubjectUser: true
},
taskTypes: []
},
unenrollFromAllAccessProfiles: {
catalogIds: ['<string>'],
catalogIdsCel: '<string>',
useSubjectUser: true,
userIdsCel: '<string>',
userRefs: [{id: '<string>'}]
},
updateUser: {
useSubjectUser: true,
userIdCel: '<string>',
userRef: {id: '<string>'},
userStatusCel: '<string>'
},
waitForDuration: {duration: '<string>'},
webhook: {payload: {}, webhookId: '<string>', webhookIdCel: '<string>'}
}
],
draftTriggers: [
{
accessConflict: {
allConflictMonitors: true,
conflictMonitorRefs: {conflictMonitorRefs: [{id: '<string>'}]}
},
appUserCreated: {appId: '<string>', appIdCel: '<string>', condition: '<string>'},
appUserUpdated: {appId: '<string>', appIdCel: '<string>', condition: '<string>'},
grantDeleted: {
grantTriggerFilter: {
accountFilter: {},
grantFilter: {},
inclusionAll: {},
inclusionCriteria: {
appIds: ['<string>'],
complianceFrameworkIds: ['<string>'],
resourceTypeIds: ['<string>'],
riskLevelIds: ['<string>']
},
inclusionList: {appEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
inclusionListCel: {appEntitlementRefsCel: '<string>'}
}
},
grantFound: {
grantTriggerFilter: {
accountFilter: {},
grantFilter: {},
inclusionAll: {},
inclusionCriteria: {
appIds: ['<string>'],
complianceFrameworkIds: ['<string>'],
resourceTypeIds: ['<string>'],
riskLevelIds: ['<string>']
},
inclusionList: {appEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
inclusionListCel: {appEntitlementRefsCel: '<string>'}
}
},
schedule: {
advanced: true,
condition: '<string>',
cronSpec: '<string>',
skipIfTrueCel: '<string>',
start: '2023-11-07T05:31:56Z',
timezone: '<string>'
},
scheduleAppUser: {
appId: '<string>',
condition: '<string>',
cronSpec: '<string>',
start: '2023-11-07T05:31:56Z',
timezone: '<string>'
},
scheduleNoUser: {
advanced: true,
cronSpec: '<string>',
start: '2023-11-07T05:31:56Z',
timezone: '<string>'
},
usageBasedRevocation: {
appId: '<string>',
enabledAt: '2023-11-07T05:31:56Z',
excludedGroupRefs: [{appId: '<string>', id: '<string>'}],
excludedUserRefs: [{id: '<string>'}],
includeUsersWithNoActivity: true,
runDelayed: {coldStartDelayDays: 123},
runImmediately: {},
targetedAppUserTypes: [],
targetedEntitlementRefs: [{appId: '<string>', id: '<string>'}],
unusedForDays: 123
},
userCreated: {condition: '<string>'},
userProfileChange: {condition: '<string>'},
webhook: {
capabilityUrl: {},
hmac: {},
jwt: {jwksUrl: '<string>'},
listenerId: '<string>'
}
}
],
enabled: true,
isDraft: true,
lastExecutedAt: '2023-11-07T05:31:56Z',
triggers: [
{
accessConflict: {
allConflictMonitors: true,
conflictMonitorRefs: {conflictMonitorRefs: [{id: '<string>'}]}
},
appUserCreated: {appId: '<string>', appIdCel: '<string>', condition: '<string>'},
appUserUpdated: {appId: '<string>', appIdCel: '<string>', condition: '<string>'},
grantDeleted: {
grantTriggerFilter: {
accountFilter: {},
grantFilter: {},
inclusionAll: {},
inclusionCriteria: {
appIds: ['<string>'],
complianceFrameworkIds: ['<string>'],
resourceTypeIds: ['<string>'],
riskLevelIds: ['<string>']
},
inclusionList: {appEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
inclusionListCel: {appEntitlementRefsCel: '<string>'}
}
},
grantFound: {
grantTriggerFilter: {
accountFilter: {},
grantFilter: {},
inclusionAll: {},
inclusionCriteria: {
appIds: ['<string>'],
complianceFrameworkIds: ['<string>'],
resourceTypeIds: ['<string>'],
riskLevelIds: ['<string>']
},
inclusionList: {appEntitlementRefs: [{appId: '<string>', id: '<string>'}]},
inclusionListCel: {appEntitlementRefsCel: '<string>'}
}
},
schedule: {
advanced: true,
condition: '<string>',
cronSpec: '<string>',
skipIfTrueCel: '<string>',
start: '2023-11-07T05:31:56Z',
timezone: '<string>'
},
scheduleAppUser: {
appId: '<string>',
condition: '<string>',
cronSpec: '<string>',
start: '2023-11-07T05:31:56Z',
timezone: '<string>'
},
scheduleNoUser: {
advanced: true,
cronSpec: '<string>',
start: '2023-11-07T05:31:56Z',
timezone: '<string>'
},
usageBasedRevocation: {
appId: '<string>',
enabledAt: '2023-11-07T05:31:56Z',
excludedGroupRefs: [{appId: '<string>', id: '<string>'}],
excludedUserRefs: [{id: '<string>'}],
includeUsersWithNoActivity: true,
runDelayed: {coldStartDelayDays: 123},
runImmediately: {},
targetedAppUserTypes: [],
targetedEntitlementRefs: [{appId: '<string>', id: '<string>'}],
unusedForDays: 123
},
userCreated: {condition: '<string>'},
userProfileChange: {condition: '<string>'},
webhook: {
capabilityUrl: {},
hmac: {},
jwt: {jwksUrl: '<string>'},
listenerId: '<string>'
}
}
]
},
updateMask: '<string>'
})
};
fetch('https://{tenantDomain}.conductor.one/api/v1/automations/{id}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"automation": {
"annotations": {},
"appId": "<string>",
"automationSteps": [
{
"accountLifecycleAction": {
"accountInContext": {},
"accountRef": {
"accountIdCel": "<string>"
},
"actionName": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
}
},
"callFunction": {
"args": {},
"functionId": "<string>"
},
"connectorAction": {
"actionName": "<string>",
"argsTemplate": {},
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"resourceTypeId": "<string>"
},
"connectorCreateAccount": {
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>",
"userIdCel": "<string>",
"userProperties": {
"displayNameCel": "<string>",
"emailCel": "<string>",
"profileAttributeCel": "<string>",
"usernameCel": "<string>"
}
},
"createAccessReview": {
"accessReviewTemplateCel": "<string>",
"accessReviewTemplateId": "<string>",
"campaignName": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"createRevokeTasks": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"appEntitlementRefsCel": "<string>",
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedAppEntitlementRefsCel": "<string>",
"revokeAll": true,
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"createRevokeTasksV2": {
"exclusionCriteria": {
"excludedAppIds": [
"<string>"
],
"excludedComplianceFrameworkIds": [
"<string>"
],
"excludedResourceTypeIds": [
"<string>"
],
"excludedRiskLevelIds": [
"<string>"
]
},
"exclusionList": {
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"exclusionListCel": {
"excludedAppEntitlementRefsCel": "<string>"
},
"exclusionNone": {},
"inclusionAccessOnly": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"evaluateExpressions": {
"expressions": [
{
"expressionCel": "<string>",
"isSecret": true,
"key": "<string>"
}
]
},
"generatePassword": {
"passwordPolicyId": "<string>",
"policy": {
"customCharacters": "<string>",
"excludedCharacters": "<string>",
"maxCharacterCount": 123,
"minCharacterCount": 123,
"noRestrictions": true,
"requireLowercase": true,
"requireNumbers": true,
"requireSpecialCharacters": true,
"requireUppercase": true
}
},
"grantEntitlements": {
"exclusionCriteria": {
"excludedAppIds": [
"<string>"
],
"excludedComplianceFrameworkIds": [
"<string>"
],
"excludedRiskLevelIds": [
"<string>"
]
},
"exclusionList": {
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"exclusionListCel": {
"excludedAppEntitlementRefsCel": "<string>"
},
"exclusionNone": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"removeFromDelegation": {
"replacementUserIdCel": "<string>",
"replacementUserRef": {
"id": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"runAutomation": {
"automationTemplateIdCel": "<string>",
"automationTemplateRef": {
"id": "<string>"
},
"context": {
"context": {}
}
},
"sendEmail": {
"body": "<string>",
"email": "<string>",
"emailCel": "<string>",
"subject": "<string>",
"title": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"sendSlackMessage": {
"body": "<string>",
"channelName": "<string>",
"channelNameCel": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"setCredential": {
"accountIdCel": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>"
},
"skipIfTrueCel": "<string>",
"stepDisplayName": "<string>",
"stepName": "<string>",
"storeCredential": {
"appIdCel": "<string>",
"credentialCel": "<string>",
"expiry": "<string>",
"labelCel": "<string>",
"maxViews": 123,
"recipientCel": "<string>",
"recipientEmailCel": "<string>",
"ttl": "<string>"
},
"taskAction": {
"close": {
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"reassign": {
"assigneeUserIdCel": "<string>",
"assigneeUserRef": {
"id": "<string>"
},
"subjectUserIdCel": "<string>",
"subjectUserRef": {
"id": "<string>"
},
"useSubjectUser": true
},
"taskTypes": []
},
"unenrollFromAllAccessProfiles": {
"catalogIds": [
"<string>"
],
"catalogIdsCel": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"updateUser": {
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
},
"userStatusCel": "<string>"
},
"waitForDuration": {
"duration": "<string>"
},
"webhook": {
"payload": {},
"webhookId": "<string>",
"webhookIdCel": "<string>"
}
}
],
"circuitBreaker": {
"observedCount": 123,
"threshold": 123,
"trippedAt": "2023-11-07T05:31:56Z"
},
"circuitBreakerMax": 123,
"context": {
"context": {}
},
"createdAt": "2023-11-07T05:31:56Z",
"currentVersion": "<string>",
"description": "<string>",
"displayName": "<string>",
"draftAutomationSteps": [
{
"accountLifecycleAction": {
"accountInContext": {},
"accountRef": {
"accountIdCel": "<string>"
},
"actionName": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
}
},
"callFunction": {
"args": {},
"functionId": "<string>"
},
"connectorAction": {
"actionName": "<string>",
"argsTemplate": {},
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"resourceTypeId": "<string>"
},
"connectorCreateAccount": {
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>",
"userIdCel": "<string>",
"userProperties": {
"displayNameCel": "<string>",
"emailCel": "<string>",
"profileAttributeCel": "<string>",
"usernameCel": "<string>"
}
},
"createAccessReview": {
"accessReviewTemplateCel": "<string>",
"accessReviewTemplateId": "<string>",
"campaignName": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"createRevokeTasks": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"appEntitlementRefsCel": "<string>",
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedAppEntitlementRefsCel": "<string>",
"revokeAll": true,
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"createRevokeTasksV2": {
"exclusionCriteria": {
"excludedAppIds": [
"<string>"
],
"excludedComplianceFrameworkIds": [
"<string>"
],
"excludedResourceTypeIds": [
"<string>"
],
"excludedRiskLevelIds": [
"<string>"
]
},
"exclusionList": {
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"exclusionListCel": {
"excludedAppEntitlementRefsCel": "<string>"
},
"exclusionNone": {},
"inclusionAccessOnly": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"evaluateExpressions": {
"expressions": [
{
"expressionCel": "<string>",
"isSecret": true,
"key": "<string>"
}
]
},
"generatePassword": {
"passwordPolicyId": "<string>",
"policy": {
"customCharacters": "<string>",
"excludedCharacters": "<string>",
"maxCharacterCount": 123,
"minCharacterCount": 123,
"noRestrictions": true,
"requireLowercase": true,
"requireNumbers": true,
"requireSpecialCharacters": true,
"requireUppercase": true
}
},
"grantEntitlements": {
"exclusionCriteria": {
"excludedAppIds": [
"<string>"
],
"excludedComplianceFrameworkIds": [
"<string>"
],
"excludedRiskLevelIds": [
"<string>"
]
},
"exclusionList": {
"excludedAppEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"exclusionListCel": {
"excludedAppEntitlementRefsCel": "<string>"
},
"exclusionNone": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"removeFromDelegation": {
"replacementUserIdCel": "<string>",
"replacementUserRef": {
"id": "<string>"
},
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"runAutomation": {
"automationTemplateIdCel": "<string>",
"automationTemplateRef": {
"id": "<string>"
},
"context": {
"context": {}
}
},
"sendEmail": {
"body": "<string>",
"email": "<string>",
"emailCel": "<string>",
"subject": "<string>",
"title": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"sendSlackMessage": {
"body": "<string>",
"channelName": "<string>",
"channelNameCel": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"setCredential": {
"accountIdCel": "<string>",
"connectorRef": {
"appId": "<string>",
"id": "<string>"
},
"passwordCel": "<string>"
},
"skipIfTrueCel": "<string>",
"stepDisplayName": "<string>",
"stepName": "<string>",
"storeCredential": {
"appIdCel": "<string>",
"credentialCel": "<string>",
"expiry": "<string>",
"labelCel": "<string>",
"maxViews": 123,
"recipientCel": "<string>",
"recipientEmailCel": "<string>",
"ttl": "<string>"
},
"taskAction": {
"close": {
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
}
},
"reassign": {
"assigneeUserIdCel": "<string>",
"assigneeUserRef": {
"id": "<string>"
},
"subjectUserIdCel": "<string>",
"subjectUserRef": {
"id": "<string>"
},
"useSubjectUser": true
},
"taskTypes": []
},
"unenrollFromAllAccessProfiles": {
"catalogIds": [
"<string>"
],
"catalogIdsCel": "<string>",
"useSubjectUser": true,
"userIdsCel": "<string>",
"userRefs": [
{
"id": "<string>"
}
]
},
"updateUser": {
"useSubjectUser": true,
"userIdCel": "<string>",
"userRef": {
"id": "<string>"
},
"userStatusCel": "<string>"
},
"waitForDuration": {
"duration": "<string>"
},
"webhook": {
"payload": {},
"webhookId": "<string>",
"webhookIdCel": "<string>"
}
}
],
"draftTriggers": [
{
"accessConflict": {
"allConflictMonitors": true,
"conflictMonitorRefs": {
"conflictMonitorRefs": [
{
"id": "<string>"
}
]
}
},
"appUserCreated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"appUserUpdated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"grantDeleted": {
"grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
}
}
},
"grantFound": {
"grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
}
}
},
"schedule": {
"advanced": true,
"condition": "<string>",
"cronSpec": "<string>",
"skipIfTrueCel": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleAppUser": {
"appId": "<string>",
"condition": "<string>",
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleNoUser": {
"advanced": true,
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"usageBasedRevocation": {
"appId": "<string>",
"enabledAt": "2023-11-07T05:31:56Z",
"excludedGroupRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedUserRefs": [
{
"id": "<string>"
}
],
"includeUsersWithNoActivity": true,
"runDelayed": {
"coldStartDelayDays": 123
},
"runImmediately": {},
"targetedAppUserTypes": [],
"targetedEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"unusedForDays": 123
},
"userCreated": {
"condition": "<string>"
},
"userProfileChange": {
"condition": "<string>"
},
"webhook": {
"capabilityUrl": {},
"hmac": {},
"jwt": {
"jwksUrl": "<string>"
},
"listenerId": "<string>"
}
}
],
"enabled": true,
"id": "<string>",
"isDraft": true,
"lastExecutedAt": "2023-11-07T05:31:56Z",
"triggers": [
{
"accessConflict": {
"allConflictMonitors": true,
"conflictMonitorRefs": {
"conflictMonitorRefs": [
{
"id": "<string>"
}
]
}
},
"appUserCreated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"appUserUpdated": {
"appId": "<string>",
"appIdCel": "<string>",
"condition": "<string>"
},
"grantDeleted": {
"grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
}
}
},
"grantFound": {
"grantTriggerFilter": {
"accountFilter": {},
"grantFilter": {},
"inclusionAll": {},
"inclusionCriteria": {
"appIds": [
"<string>"
],
"complianceFrameworkIds": [
"<string>"
],
"resourceTypeIds": [
"<string>"
],
"riskLevelIds": [
"<string>"
]
},
"inclusionList": {
"appEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
]
},
"inclusionListCel": {
"appEntitlementRefsCel": "<string>"
}
}
},
"schedule": {
"advanced": true,
"condition": "<string>",
"cronSpec": "<string>",
"skipIfTrueCel": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleAppUser": {
"appId": "<string>",
"condition": "<string>",
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"scheduleNoUser": {
"advanced": true,
"cronSpec": "<string>",
"start": "2023-11-07T05:31:56Z",
"timezone": "<string>"
},
"usageBasedRevocation": {
"appId": "<string>",
"enabledAt": "2023-11-07T05:31:56Z",
"excludedGroupRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"excludedUserRefs": [
{
"id": "<string>"
}
],
"includeUsersWithNoActivity": true,
"runDelayed": {
"coldStartDelayDays": 123
},
"runImmediately": {},
"targetedAppUserTypes": [],
"targetedEntitlementRefs": [
{
"appId": "<string>",
"id": "<string>"
}
],
"unusedForDays": 123
},
"userCreated": {
"condition": "<string>"
},
"userProfileChange": {
"condition": "<string>"
},
"webhook": {
"capabilityUrl": {},
"hmac": {},
"jwt": {
"jwksUrl": "<string>"
},
"listenerId": "<string>"
}
}
]
},
"webhookCapabilityUrl": "<string>",
"webhookHmacSecret": "<string>"
}Update Automation
Update an existing automation’s properties, steps, or triggers using a field mask.
package main
import(
"context"
"github.com/conductorone/conductorone-sdk-go/pkg/models/shared"
conductoronesdkgo "github.com/conductorone/conductorone-sdk-go"
"github.com/conductorone/conductorone-sdk-go/pkg/models/operations"
"log"
)
func main() {
ctx := context.Background()
s := conductoronesdkgo.New(
conductoronesdkgo.WithSecurity(shared.Security{
BearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
Oauth: "<YOUR_OAUTH_HERE>",
}),
)
res, err := s.Automation.UpdateAutomation(ctx, operations.C1APIAutomationsV1AutomationServiceUpdateAutomationRequest{
ID: "<id>",
})
if err != nil {
log.Fatal(err)
}
if res.UpdateAutomationResponse != nil {
// handle response
}
}import { ConductoroneSDKTypescript } from "conductorone-sdk-typescript";
const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
security: {
bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
oauth: "<YOUR_OAUTH_HERE>",
},
});
async function run() {
const result = await conductoroneSDKTypescript.automation.updateAutomation({
id: "<id>",
});
console.log(result);
}
run();Authorizations
Bearer authentication header of the form Bearer <token>, where <token> is your auth token.
This API uses OAuth2 with the Client Credential flow. Client Credentials must be sent in the BODY, not the headers. For an example of how to implement this, refer to the c1TokenSource.Token() function.
Path Parameters
The id field.
Body
Response
Successful response
The UpdateAutomationResponse message.
The Automation message.
This message contains a oneof named disabled_reason. Only a single field of the following list may be set at a time:
- circuitBreaker
Show child attributes
Show child attributes
One-time absolute webhook URL for capability URL authentication, shown once when the trigger is saved. Contains the full URL including the embedded token (e.g. https://tenant.conductorone.com/api/v1/webhooks/incoming/{id}/t/{token}). Populated only when the webhook trigger uses capability URL authentication.
One-time HMAC shared secret, shown once when the trigger is saved. Populated only when the webhook trigger uses HMAC authentication.
Was this page helpful?